
// OpenGLTrackView.h : COpenGLTrackView NX̃C^[tFCX
//

#pragma once

#include "OpenGLBaseView.h"

// TrackingMode
enum ETRACKINGMODE
{
	TM_NONE = 0,
	TM_ROTATION,
	TM_PAN,
	TM_ZOOM,
};

class COpenGLTrackView : public COpenGLBaseView
{
	// oϐ
private:
	CPoint			m_ptLast;
	GLfloat			m_f3RenderingCenter[3];		// `撆S
	GLfloat			m_fRenderingRate;			// g嗦
	GLfloat			m_f16ViewingTransformMatrix[16];
protected:
	ETRACKINGMODE	m_eTrackingMode;

	// o֐
private:
	void	BeginTracking( CPoint point, ETRACKINGMODE eTrackingMode );
	void	EndTracking();
	bool	SetupProjectionMatrix();
	bool	SetupModelViewMatrix();
protected:
	virtual void	DoTracking( CPoint point );

protected: // VÂݍ쐬܂B
	COpenGLTrackView();
	DECLARE_DYNCREATE(COpenGLTrackView)

// 
public:
	CDocument* GetDocument() const;

// 
public:

// I[o[Ch
public:
//	virtual void OnDraw(CDC* pDC);  // ̃r[`悷邽߂ɃI[o[Ch܂B
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// 
public:
	virtual ~COpenGLTrackView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnLButtonDown( UINT nFlags, CPoint point );
	afx_msg void OnLButtonUp( UINT nFlags, CPoint point );
	afx_msg void OnMButtonDown( UINT nFlags, CPoint point );
	afx_msg void OnMButtonUp( UINT nFlags, CPoint point );
	afx_msg void OnMouseMove( UINT nFlags, CPoint point );
	afx_msg BOOL OnMouseWheel( UINT nFlags, short zDelta, CPoint pt );
};

#ifndef _DEBUG  // OpenGLTrackView.cpp ̃fobO o[W
inline CDocument* COpenGLTrackView::GetDocument() const
   { return reinterpret_cast<CDocument*>(m_pDocument); }
#endif

